# Tecnalia smartdatalab ca esilab.org

## Objective

This is an **autogenerated** ca for tecnalia internal use, the purpose is to avoid disgusting security screens in our systems and projects. We will use this ca to sign certificates for our internal systems, so that we avoid security warnings and we could enable internal trust relationships.

## How to install the certificate
The instalation of the certificate depends both on the operating system and in some cases on the specific application. There are some applications, such as firefox, that does not relay in the operating system certificates repository to validate incoming certificates.

### Windows
In windows we can use the cmd or powershell. 
#### cmd
To enter into the cmd, press windows key + r, write cmd, and press enter. That will open the cmd console. Write the following commands to install this certificate. Adding certificate this way will make it valid in chrome, edge and internet explorer. 
<pre>
set CA_RAW_URL=https://git.code.tecnalia.com/smartdatalab/public/ca/-/raw/master/ca.crt.pem
set CA_FILE_PATH=%TEMP%\ca.crt.pem
echo download ca from %CA_RAW_URL% to %CA_FILE_PATH%
powershell -command "$cli = New-Object System.Net.WebClient; $cli.DownloadFile('%CA_RAW_URL%', '%CA_FILE_PATH%')" 
echo check downloaded ca
type %CA_FILE_PATH%
echo add ca to the certificate store
certutil -addstore -user -f "Root" "%CA_FILE_PATH%"
</pre>

### Linux
In linux we can use terminal. 
#### cmd
To enter into the terminal, press ctrl + alt + t. That will open the terminal console. Write the following commands to install this certificate. Adding certificate this way will make it valid in chrome, and firefox. 
<pre>
export CA_RAW_URL=https://git.code.tecnalia.com/smartdatalab/public/ca/-/raw/master/ca.crt.pem
export TEMP_PATH=$(mktemp -d)
export CA_FILE_PATH=$TEMP_PATH/ca.crt.pem
echo download ca from $CA_RAW_URL to $CA_FILE_PATH
wget $CA_RAW_URL -O $CA_FILE_PATH
echo check downloaded ca
[ -f $CA_FILE_PATH ] && echo "File exist" || echo "File does not exist"
echo add ca to the certificate store
sudo cp $CA_FILE_PATH /usr/local/share/ca-certificates/ca.crt.crt
sudo update-ca-certificates
</pre>

## How to create certificates based on it

To create certificates based on it for the moment we have to do manually, to do so you can use the private key stored in the private repository  


